# -*- coding: utf-8 -*-
# Generated by Django 1.11 on 2017-07-10 09:27
from __future__ import unicode_literals

import django.contrib.postgres.fields.jsonb
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Broadcast',
            fields=[
                ('broadcast_id', models.AutoField(help_text=b'ID', max_length=10, primary_key=True, serialize=False)),
                ('broadcast_type', models.CharField(choices=[(b'1', b'Processing'), (b'2', b'Message'), (b'3', b'Notification')], default=b'1', help_text=b'Broadcast Type', max_length=2)),
                ('sender', models.CharField(help_text=b'Broadcast Sender', max_length=100, null=True)),
                ('receiver', models.CharField(help_text=b'Broadcast Receiver', max_length=100, null=True)),
                ('process_id', models.CharField(blank=True, help_text=b'Process ID', max_length=50, null=True)),
                ('request_id', models.CharField(blank=True, help_text=b'Request ID', max_length=50, null=True)),
                ('queued_at', models.DateTimeField(blank=True, help_text=b'Queued Start', null=True)),
                ('running_at', models.DateTimeField(blank=True, help_text=b'Running Start', null=True)),
                ('terminated_at', models.DateTimeField(blank=True, help_text=b'terminated Start', null=True)),
                ('success_at', models.DateTimeField(blank=True, help_text=b'Success Start', null=True)),
                ('cancelled_at', models.DateTimeField(blank=True, help_text=b'Canceld Start', null=True)),
                ('exec_status', models.CharField(choices=[(b'SUCCESS', b'SUCCESS'), (b'WARNING', b'WARNING'), (b'ERROR', b'ERROR'), (b'CANCELLED', b'CANCELLED'), (b'RUNNING', b'RUNNING'), (b'QUEUED', b'QUEUED')], help_text=b'Exec Status', max_length=10)),
                ('message_hdr', models.CharField(help_text=b'Broadcast Header', max_length=60)),
                ('message_dtl', models.CharField(help_text=b'Broadcast Detail', max_length=200)),
                ('message_data', models.TextField(help_text=b'Message Data', max_length=35, verbose_name='text')),
                ('message_dttm', models.DateTimeField(help_text=b'Message DateTime', verbose_name='created at')),
                ('message_status', models.CharField(choices=[(b'READ', b'READ'), (b'UNREAD', b'UNREAD'), (b'DELETED', b'DELETED')], default=b'UNREAD', help_text=b'', max_length=10)),
            ],
            options={
                'db_table': 'sunrise_contrib_notifications_broadcasts',
            },
        ),
        migrations.CreateModel(
            name='UserPreferences',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('username', models.CharField(max_length=100)),
                ('data', django.contrib.postgres.fields.jsonb.JSONField(null=True)),
            ],
            options={
                'db_table': 'user_preferences',
            },
        ),
        migrations.CreateModel(
            name='UserTheme',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=30)),
                ('data', django.contrib.postgres.fields.jsonb.JSONField(null=True)),
            ],
            options={
                'db_table': 'user_theme',
            },
        ),
    ]
